Index: src/language/lexer/variable-parser.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/variable-parser.c,v
retrieving revision 1.12
diff -u -p -r1.12 variable-parser.c
--- src/language/lexer/variable-parser.c	5 Dec 2006 15:10:21 -0000	1.12
+++ src/language/lexer/variable-parser.c	10 Dec 2006 03:30:30 -0000
@@ -30,6 +30,7 @@
 #include <data/procedure.h>
 #include <data/variable.h>
 #include <libpspp/alloc.h>
+#include <libpspp/assertion.h>
 #include <libpspp/bit-vector.h>
 #include <libpspp/hash.h>
 #include <libpspp/message.h>
@@ -175,11 +176,17 @@ add_variable (struct variable ***v, size
            && dict_class_from_id (add_name) == DC_SCRATCH)
     msg (SE, _("Scratch variables (such as %s) are not allowed "
                "here."), add_name);
-  else if ((pv_opts & PV_SAME_TYPE) && *nv
+  else if ((pv_opts & (PV_SAME_TYPE | PV_SAME_WIDTH)) && *nv
            && var_get_type (add) != var_get_type ((*v)[0])) 
     msg (SE, _("%s and %s are not the same type.  All variables in "
                "this variable list must be of the same type.  %s "
-               "will be omitted from list."),
+               "will be omitted from the list."),
+         var_get_name ((*v)[0]), add_name, add_name);
+  else if ((pv_opts & PV_SAME_WIDTH) && *nv
+           && var_get_width (add) != var_get_width ((*v)[0]))
+    msg (SE, _("%s and %s are string variables with different widths.  "
+               "All variables in this variable list must have the "
+               "same width.  %s will be omttied from the list."),
          var_get_name ((*v)[0]), add_name, add_name);
   else if ((pv_opts & PV_NO_DUPLICATE) && included[idx]) 
     msg (SE, _("Variable %s appears twice in variable list."), add_name);
@@ -229,11 +236,12 @@ parse_var_set_vars (struct lexer *lexer,
   assert (v != NULL);
   assert (nv != NULL);
 
-  /* At most one of PV_NUMERIC, PV_STRING, PV_SAME_TYPE may be
-     specified. */
-  assert ((((pv_opts & PV_NUMERIC) != 0)
-           + ((pv_opts & PV_STRING) != 0)
-           + ((pv_opts & PV_SAME_TYPE) != 0)) <= 1);
+  /* At most one of PV_NUMERIC, PV_STRING, PV_SAME_TYPE,
+     PV_SAME_WIDTH may be specified. */
+  assert (((pv_opts & PV_NUMERIC) != 0)
+          + ((pv_opts & PV_STRING) != 0)
+          + ((pv_opts & PV_SAME_TYPE) != 0)
+          + ((pv_opts & PV_SAME_WIDTH) != 0) <= 1);
 
   /* PV_DUPLICATE and PV_NO_DUPLICATE are incompatible. */
   assert (!(pv_opts & PV_DUPLICATE) || !(pv_opts & PV_NO_DUPLICATE));
@@ -252,8 +260,13 @@ parse_var_set_vars (struct lexer *lexer,
       size_t i;
       
       included = xcalloc (var_set_get_cnt (vs), sizeof *included);
-      for (i = 0; i < *nv; i++)
-        included[(*v)[i]->index] = 1;
+      for (i = 0; i < *nv; i++) 
+        {
+          size_t index;
+          if (!var_set_lookup_var_idx (vs, var_get_name ((*v)[i]), &index))
+            NOT_REACHED ();
+          included[index] = 1; 
+        }
     }
   else
     included = NULL;
@@ -687,7 +700,7 @@ dict_var_set_lookup_var_idx (const struc
   struct variable *v = dict_lookup_var (d, name);
   if (v != NULL) 
     {
-      *idx = v->index;
+      *idx = var_get_dict_index (v);
       return true;
     }
   else
@@ -748,11 +761,12 @@ array_var_set_lookup_var_idx (const stru
                               size_t *idx) 
 {
   struct array_var_set *avs = vs->aux;
-  struct variable v, *vp, *const *vpp;
+  struct variable *v, *const *vpp;
 
-  strcpy (v.name, name);
-  vp = &v;
-  vpp = hsh_find (avs->name_tab, &vp);
+  v = var_create (name, 0);
+  vpp = hsh_find (avs->name_tab, &v);
+  var_destroy (v);
+  
   if (vpp != NULL) 
     {
       *idx = vpp - avs->var;
@@ -791,8 +805,8 @@ var_set_create_from_array (struct variab
   avs->var = var;
   avs->var_cnt = var_cnt;
   avs->name_tab = hsh_create (2 * var_cnt,
-                              compare_var_ptr_names, hash_var_ptr_name, NULL,
-                              NULL);
+                              compare_var_ptrs_by_name, hash_var_ptr_by_name,
+                              NULL, NULL);
   for (i = 0; i < var_cnt; i++)
     if (hsh_insert (avs->name_tab, (void *) &var[i]) != NULL) 
       {
Index: src/language/lexer/variable-parser.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/variable-parser.h,v
retrieving revision 1.5
diff -u -p -r1.5 variable-parser.h
--- src/language/lexer/variable-parser.h	11 Nov 2006 23:10:00 -0000	1.5
+++ src/language/lexer/variable-parser.h	10 Dec 2006 03:30:30 -0000
@@ -53,7 +53,8 @@ enum
     PV_NUMERIC = 0020,		/* Vars must be numeric. */
     PV_STRING = 0040,		/* Vars must be string. */
     PV_SAME_TYPE = 00100,	/* All vars must be the same type. */
-    PV_NO_SCRATCH = 00200 	/* Disallow scratch variables. */
+    PV_SAME_WIDTH = 00200,	/* All vars must be the same type and width. */
+    PV_NO_SCRATCH = 00400 	/* Disallow scratch variables. */
   };
 
 struct variable *parse_variable (struct lexer *, const struct dictionary *);
Index: src/language/stats/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/ChangeLog,v
retrieving revision 1.34
diff -u -p -r1.34 ChangeLog
--- src/language/stats/ChangeLog	7 Dec 2006 06:31:04 -0000	1.34
+++ src/language/stats/ChangeLog	10 Dec 2006 03:30:30 -0000
@@ -1,3 +1,8 @@
+Sat Dec  9 18:47:51 2006  Ben Pfaff  <blp@gnu.org>
+
+	* regression.q (is_depvar): Compare variable pointers instead of
+	variable names.
+
 Thu Dec  7 15:26:25 WST 2006 John Darrington <john@darrington.wattle.id.au>
 
 	* examine.q: Allocated the categorical values for the dependent and 
Index: src/language/stats/aggregate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/aggregate.c,v
retrieving revision 1.21
diff -u -p -r1.21 aggregate.c
--- src/language/stats/aggregate.c	5 Dec 2006 15:10:21 -0000	1.21
+++ src/language/stats/aggregate.c	10 Dec 2006 03:30:31 -0000
@@ -27,6 +27,7 @@
 #include <data/casefile.h>
 #include <data/dictionary.h>
 #include <data/file-handle-def.h>
+#include <data/format.h>
 #include <data/procedure.h>
 #include <data/settings.h>
 #include <data/storage-stream.h>
@@ -93,36 +94,36 @@ struct agr_func
   {
     const char *name;		/* Aggregation function name. */
     size_t n_args;              /* Number of arguments. */
-    int alpha_type;		/* When given ALPHA arguments, output type. */
+    enum var_type alpha_type;   /* When given ALPHA arguments, output type. */
     struct fmt_spec format;	/* Format spec if alpha_type != ALPHA. */
   };
 
 /* Attributes of aggregation functions. */
 static const struct agr_func agr_func_tab[] = 
   {
-    {"<NONE>",  0, -1,      {0, 0, 0}},
-    {"SUM",     0, -1,      {FMT_F, 8, 2}},
-    {"MEAN",	0, -1,      {FMT_F, 8, 2}},
-    {"SD",      0, -1,      {FMT_F, 8, 2}},
-    {"MAX",     0, ALPHA,   {-1, -1, -1}}, 
-    {"MIN",     0, ALPHA,   {-1, -1, -1}}, 
-    {"PGT",     1, NUMERIC, {FMT_F, 5, 1}},      
-    {"PLT",     1, NUMERIC, {FMT_F, 5, 1}},       
-    {"PIN",     2, NUMERIC, {FMT_F, 5, 1}},       
-    {"POUT",    2, NUMERIC, {FMT_F, 5, 1}},       
-    {"FGT",     1, NUMERIC, {FMT_F, 5, 3}},       
-    {"FLT",     1, NUMERIC, {FMT_F, 5, 3}},       
-    {"FIN",     2, NUMERIC, {FMT_F, 5, 3}},       
-    {"FOUT",    2, NUMERIC, {FMT_F, 5, 3}},       
-    {"N",       0, NUMERIC, {FMT_F, 7, 0}},       
-    {"NU",      0, NUMERIC, {FMT_F, 7, 0}},       
-    {"NMISS",   0, NUMERIC, {FMT_F, 7, 0}},       
-    {"NUMISS",  0, NUMERIC, {FMT_F, 7, 0}},       
-    {"FIRST",   0, ALPHA,   {-1, -1, -1}}, 
-    {"LAST",    0, ALPHA,   {-1, -1, -1}},
-    {NULL,      0, -1,      {-1, -1, -1}},
-    {"N",       0, NUMERIC, {FMT_F, 7, 0}},
-    {"NU",      0, NUMERIC, {FMT_F, 7, 0}},
+    {"<NONE>",  0, -1,          {0, 0, 0}},
+    {"SUM",     0, -1,          {FMT_F, 8, 2}},
+    {"MEAN",	0, -1,          {FMT_F, 8, 2}},
+    {"SD",      0, -1,          {FMT_F, 8, 2}},
+    {"MAX",     0, VAR_STRING,  {-1, -1, -1}}, 
+    {"MIN",     0, VAR_STRING,  {-1, -1, -1}}, 
+    {"PGT",     1, VAR_NUMERIC, {FMT_F, 5, 1}},      
+    {"PLT",     1, VAR_NUMERIC, {FMT_F, 5, 1}},       
+    {"PIN",     2, VAR_NUMERIC, {FMT_F, 5, 1}},       
+    {"POUT",    2, VAR_NUMERIC, {FMT_F, 5, 1}},       
+    {"FGT",     1, VAR_NUMERIC, {FMT_F, 5, 3}},       
+    {"FLT",     1, VAR_NUMERIC, {FMT_F, 5, 3}},       
+    {"FIN",     2, VAR_NUMERIC, {FMT_F, 5, 3}},       
+    {"FOUT",    2, VAR_NUMERIC, {FMT_F, 5, 3}},       
+    {"N",       0, VAR_NUMERIC, {FMT_F, 7, 0}},       
+    {"NU",      0, VAR_NUMERIC, {FMT_F, 7, 0}},       
+    {"NMISS",   0, VAR_NUMERIC, {FMT_F, 7, 0}},       
+    {"NUMISS",  0, VAR_NUMERIC, {FMT_F, 7, 0}},       
+    {"FIRST",   0, VAR_STRING,  {-1, -1, -1}}, 
+    {"LAST",    0, VAR_STRING,  {-1, -1, -1}},
+    {NULL,      0, -1,          {-1, -1, -1}},
+    {"N",       0, VAR_NUMERIC, {FMT_F, 7, 0}},
+    {"NU",      0, VAR_NUMERIC, {FMT_F, 7, 0}},
   };
 
 /* Missing value types. */
@@ -494,13 +495,15 @@ parse_aggregate_functions (struct lexer 
 		if (lex_token (lexer) == T_STRING)
 		  {
 		    arg[i].c = ds_xstrdup (lex_tokstr (lexer));
-		    type = ALPHA;
+		    type = VAR_STRING;
 		  }
 		else if (lex_is_number (lexer))
 		  {
 		    arg[i].f = lex_tokval (lexer);
-		    type = NUMERIC;
-		  } else {
+		    type = VAR_NUMERIC;
+		  }
+                else
+                  {
 		    msg (SE, _("Missing argument %d to %s."), i + 1,
                          function->name);
 		    goto error;
@@ -587,12 +590,12 @@ parse_aggregate_functions (struct lexer 
 		    v->string = xmalloc (var_get_width (src[i]));
 		  }
 
-		if (function->alpha_type == ALPHA)
+		if (function->alpha_type == VAR_STRING)
 		  destvar = dict_clone_var (agr->dict, v->src, dest[i]);
 		else
                   {
                     assert (var_is_numeric (v->src)
-                            || function->alpha_type == NUMERIC);
+                            || function->alpha_type == VAR_NUMERIC);
                     destvar = dict_create_var (agr->dict, dest[i], 0);
                     if (destvar != NULL) 
                       {
@@ -771,7 +774,7 @@ accumulate_aggregate_info (struct agr_pr
   for (iter = agr->agr_vars; iter; iter = iter->next)
     if (iter->src)
       {
-	const union value *v = case_data (input, iter->src->fv);
+	const union value *v = case_data (input, iter->src);
         int src_width = var_get_width (iter->src);
 
 	if (iter->include_missing
@@ -944,8 +947,8 @@ dump_aggregate_info (struct agr_proc *ag
       {
         struct variable *v = agr->break_vars[i];
         size_t value_cnt = var_get_value_cnt (v);
-        memcpy (case_data_rw (output, value_idx),
-                case_data (&agr->break_case, v->fv),
+        memcpy (case_data_rw_idx (output, value_idx),
+                case_data (&agr->break_case, v),
                 sizeof (union value) * value_cnt);
         value_idx += value_cnt; 
       }
@@ -956,7 +959,7 @@ dump_aggregate_info (struct agr_proc *ag
   
     for (i = agr->agr_vars; i; i = i->next)
       {
-	union value *v = case_data_rw (output, i->dest->fv);
+	union value *v = case_data_rw (output, i->dest);
 
 	if (agr->missing == COLUMNWISE && i->missing != 0
 	    && (i->function & FUNC) != N && (i->function & FUNC) != NU
Index: src/language/stats/autorecode.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/autorecode.c,v
retrieving revision 1.15
diff -u -p -r1.15 autorecode.c
--- src/language/stats/autorecode.c	5 Dec 2006 15:10:21 -0000	1.15
+++ src/language/stats/autorecode.c	10 Dec 2006 03:30:31 -0000
@@ -285,12 +285,12 @@ autorecode_trns_proc (void *trns_, struc
       union arc_value v;
 
       if (var_is_numeric (spec->src))
-        v.f = case_num (c, spec->src->fv);
+        v.f = case_num (c, spec->src);
       else
-        v.c = (char *) case_str (c, spec->src->fv);
+        v.c = (char *) case_str (c, spec->src);
       item = hsh_force_find (spec->items, &v);
 
-      case_data_rw (c, spec->dest->fv)->f = item->to;
+      case_data_rw (c, spec->dest)->f = item->to;
     }
   return TRNS_CONTINUE;
 }
@@ -357,9 +357,9 @@ autorecode_proc_func (const struct ccase
       union arc_value v, *vp, **vpp;
 
       if (var_is_numeric (arc->src_vars[i]))
-        v.f = case_num (c, arc->src_vars[i]->fv);
+        v.f = case_num (c, arc->src_vars[i]);
       else
-        v.c = (char *) case_str (c, arc->src_vars[i]->fv);
+        v.c = (char *) case_str (c, arc->src_vars[i]);
 
       vpp = (union arc_value **) hsh_probe (arc->src_values[i], &v);
       if (*vpp == NULL)
Index: src/language/stats/crosstabs.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/crosstabs.q,v
retrieving revision 1.24
diff -u -p -r1.24 crosstabs.q
--- src/language/stats/crosstabs.q	5 Dec 2006 15:10:21 -0000	1.24
+++ src/language/stats/crosstabs.q	10 Dec 2006 03:30:33 -0000
@@ -39,6 +39,7 @@
 #include <data/case.h>
 #include <data/data-out.h>
 #include <data/dictionary.h>
+#include <data/format.h>
 #include <data/procedure.h>
 #include <data/value-labels.h>
 #include <data/variable.h>
@@ -131,9 +132,7 @@ struct var_range
 static inline struct var_range *
 get_var_range (struct variable *v) 
 {
-  assert (v != NULL);
-  assert (v->aux != NULL);
-  return v->aux;
+  return var_get_aux (v);
 }
 
 /* Indexes into crosstab.v. */
@@ -592,7 +591,7 @@ calc_general (const struct ccase *c, voi
 	assert (x != NULL);
 	for (j = 0; j < x->nvar; j++)
 	  {
-            const union value *v = case_data (c, x->vars[j]->fv);
+            const union value *v = case_data (c, x->vars[j]);
 	    if ((cmd.miss == CRS_TABLE && var_is_value_missing (x->vars[j], v))
 		|| (cmd.miss == CRS_INCLUDE
 		    && var_is_value_system_missing (x->vars[j], v)))
@@ -602,10 +601,10 @@ calc_general (const struct ccase *c, voi
 	      }
 	      
 	    if (var_is_numeric (x->vars[j]))
-	      te->values[j].f = case_num (c, x->vars[j]->fv);
+	      te->values[j].f = case_num (c, x->vars[j]);
 	    else
 	      {
-		memcpy (te->values[j].s, case_str (c, x->vars[j]->fv),
+		memcpy (te->values[j].s, case_str (c, x->vars[j]),
                         var_get_width (x->vars[j]));
 	      
 		/* Necessary in order to simplify comparisons. */
@@ -661,7 +660,7 @@ calc_integer (const struct ccase *c, voi
 	{
 	  struct variable *const v = x->vars[i];
           struct var_range *vr = get_var_range (v);
-	  double value = case_num (c, v->fv);
+	  double value = case_num (c, v);
 	  
 	  /* Note that the first test also rules out SYSMIS. */
 	  if ((value < vr->min || value >= vr->max)
@@ -680,10 +679,10 @@ calc_integer (const struct ccase *c, voi
       
       {
         struct variable *row_var = x->vars[ROW_VAR];
-	const int row = case_num (c, row_var->fv) - get_var_range (row_var)->min;
+	const int row = case_num (c, row_var) - get_var_range (row_var)->min;
 
         struct variable *col_var = x->vars[COL_VAR];
-	const int col = case_num (c, col_var->fv) - get_var_range (col_var)->min;
+	const int col = case_num (c, col_var) - get_var_range (col_var)->min;
 
 	const int col_dim = get_var_range (col_var)->count;
 
@@ -1667,7 +1666,7 @@ table_value_missing (struct tab_table *t
   struct substring s;
   const struct fmt_spec *print = var_get_print_format (var);
 
-  const char *label = val_labs_find (var->val_labs, *v);
+  const char *label = var_lookup_value_label (var, v);
   if (label) 
     {
       tab_text (table, c, r, TAB_LEFT, label);
Index: src/language/stats/descriptives.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/descriptives.c,v
retrieving revision 1.18
diff -u -p -r1.18 descriptives.c
--- src/language/stats/descriptives.c	5 Dec 2006 15:10:21 -0000	1.18
+++ src/language/stats/descriptives.c	10 Dec 2006 03:30:34 -0000
@@ -64,11 +64,10 @@ enum dsc_missing_type
    calculating a Z-score. */
 struct dsc_z_score
   {
-    int src_idx;                /* Source index into case data. */
-    int dst_idx;                /* Destination index into case data. */
+    struct variable *src_var;   /* Variable on which z-score is based. */
+    struct variable *z_var;     /* New z-score variable. */
     double mean;		/* Distribution mean. */
     double std_dev;		/* Distribution standard deviation. */
-    struct variable *v;         /* Variable on which z-score is based. */
   };
 
 /* DESCRIPTIVES transformation (for calculating Z-scores). */
@@ -596,7 +595,7 @@ descriptives_trns_proc (void *trns_, str
       assert(t->vars);
       for (vars = t->vars; vars < t->vars + t->var_cnt; vars++)
 	{
-	  double score = case_num (c, (*vars)->fv);
+	  double score = case_num (c, *vars);
 	  if ( score == SYSMIS
                || (!t->include_user_missing 
                    && var_is_num_user_missing (*vars, score)))
@@ -609,13 +608,13 @@ descriptives_trns_proc (void *trns_, str
       
   for (z = t->z_scores; z < t->z_scores + t->z_score_cnt; z++)
     {
-      double input = case_num (c, z->src_idx);
-      double *output = &case_data_rw (c, z->dst_idx)->f;
+      double input = case_num (c, z->src_var);
+      double *output = &case_data_rw (c, z->z_var)->f;
 
       if (z->mean == SYSMIS || z->std_dev == SYSMIS 
 	  || all_sysmis || input == SYSMIS 
 	  || (!t->include_user_missing
-              && var_is_num_user_missing (z->v, input)))
+              && var_is_num_user_missing (z->src_var, input)))
 	*output = SYSMIS;
       else
 	*output = (input - z->mean) / z->std_dev;
@@ -677,11 +676,10 @@ setup_z_trns (struct dsc_proc *dsc, stru
                                              var_to_string (dv->v)));
 
           z = &t->z_scores[cnt++];
-          z->src_idx = dv->v->fv;
-          z->dst_idx = dst_var->fv;
+          z->src_var = dv->v;
+          z->z_var = dst_var;
           z->mean = dv->stats[DSC_MEAN];
           z->std_dev = dv->stats[DSC_STDDEV];
-	  z->v = dv->v;
 	}
     }
 
@@ -741,7 +739,7 @@ calc_descriptives (const struct ccase *f
       for (i = 0; i < dsc->var_cnt; i++) 
         {
           struct dsc_var *dv = &dsc->vars[i];
-          double x = case_num (&c, dv->v->fv);
+          double x = case_num (&c, dv->v);
           
           if (dsc->missing_type != DSC_LISTWISE
               && (x == SYSMIS
@@ -783,7 +781,7 @@ calc_descriptives (const struct ccase *f
           for (i = 0; i < dsc->var_cnt; i++) 
             {
               struct dsc_var *dv = &dsc->vars[i];
-              double x = case_num (&c, dv->v->fv);
+              double x = case_num (&c, dv->v);
           
               if (dsc->missing_type != DSC_LISTWISE
                   && (x == SYSMIS
@@ -850,7 +848,7 @@ listwise_missing (struct dsc_proc *dsc, 
   for (i = 0; i < dsc->var_cnt; i++)
     {
       struct dsc_var *dv = &dsc->vars[i];
-      double x = case_num (c, dv->v->fv);
+      double x = case_num (c, dv->v);
 
       if (x == SYSMIS
           || (!dsc->include_user_missing
Index: src/language/stats/examine.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/examine.q,v
retrieving revision 1.19
diff -u -p -r1.19 examine.q
--- src/language/stats/examine.q	7 Dec 2006 06:31:04 -0000	1.19
+++ src/language/stats/examine.q	10 Dec 2006 03:30:35 -0000
@@ -649,13 +649,13 @@ factor_calc (const struct ccase *c, int 
       union value *indep_vals[2] ;
 
       indep_vals[0] = value_dup (
-				 case_data (c, fctr->indep_var[0]->fv),
+				 case_data (c, fctr->indep_var[0]),
 				 var_get_width (fctr->indep_var[0])
 				 );
 
       if ( fctr->indep_var[1] )
 	indep_vals[1] = value_dup (
-				   case_data (c, fctr->indep_var[1]->fv),
+				   case_data (c, fctr->indep_var[1]),
 				   var_get_width (fctr->indep_var[1])
 				   );
       else
@@ -692,7 +692,7 @@ factor_calc (const struct ccase *c, int 
 	{
 	  const struct variable *var = dependent_vars[v];
 	  union value *val = value_dup (
-					case_data (c, var->fv),
+					case_data (c, var),
 					var_get_width (var)
 					);
 
@@ -759,7 +759,7 @@ run_examine (const struct ccase *first, 
 	    {
 	      const struct variable *var = dependent_vars[v];
 	      union value *val = value_dup (
-						  case_data (&c, var->fv),
+						  case_data (&c, var),
 						  var_get_width (var)
 						  );
 
@@ -774,7 +774,7 @@ run_examine (const struct ccase *first, 
 	{
 	  const struct variable *var = dependent_vars[v];
 	  union value *val = value_dup (
-					case_data (&c, var->fv),
+					case_data (&c, var),
 					var_get_width (var)
 					);
 
@@ -1059,8 +1059,8 @@ show_summary (struct variable **dependen
 			    (i * n_factors ) + count +
 			    heading_rows,
 			    TAB_LEFT | TAT_TITLE,
-			    value_to_string ((*fs)->id[0],
-					     fctr->indep_var[0])
+			    var_get_value_name (fctr->indep_var[0],
+                                                (*fs)->id[0])
 			    );
 
 		  if (fctr->indep_var[1] && count > 0 )
@@ -1078,7 +1078,7 @@ show_summary (struct variable **dependen
 			  (i * n_factors ) + count +
 			  heading_rows,
 			  TAB_LEFT | TAT_TITLE,
-			  value_to_string ((*fs)->id[1], fctr->indep_var[1])
+			  var_get_value_name (fctr->indep_var[1], (*fs)->id[1])
 			  );
 
 	      populate_summary (tbl, heading_columns,
@@ -1234,7 +1234,8 @@ show_extremes (struct variable **depende
 		  tab_text (tbl,
 			    1, row,
 			    TAB_LEFT | TAT_TITLE,
-			    value_to_string ((*fs)->id[0], fctr->indep_var[0])
+			    var_get_value_name (fctr->indep_var[0],
+                                                (*fs)->id[0])
 			    );
 		}
 
@@ -1246,7 +1247,7 @@ show_extremes (struct variable **depende
 	      if ( fctr->indep_var[1])
 		tab_text (tbl, 2, row,
 			  TAB_LEFT | TAT_TITLE,
-			  value_to_string ((*fs)->id[1], fctr->indep_var[1])
+			  var_get_value_name (fctr->indep_var[1], (*fs)->id[1])
 			  );
 
 	      populate_extremes (tbl, heading_columns - 2,
@@ -1471,7 +1472,8 @@ show_descriptives (struct variable **dep
 		  tab_text (tbl,
 			    1, row,
 			    TAB_LEFT | TAT_TITLE,
-			    value_to_string ((*fs)->id[0], fctr->indep_var[0])
+			    var_get_value_name (fctr->indep_var[0],
+                                                (*fs)->id[0])
 			    );
 		}
 
@@ -1483,7 +1485,7 @@ show_descriptives (struct variable **dep
 	      if ( fctr->indep_var[1])
 		tab_text (tbl, 2, row,
 			  TAB_LEFT | TAT_TITLE,
-			  value_to_string ((*fs)->id[1], fctr->indep_var[1])
+			  var_get_value_name (fctr->indep_var[1], (*fs)->id[1])
 			  );
 
 	      populate_descriptives (tbl, heading_columns - 2,
@@ -2097,7 +2099,8 @@ show_percentiles (struct variable **depe
 		  tab_text (tbl,
 			    1, row,
 			    TAB_LEFT | TAT_TITLE,
-			    value_to_string ((*fs)->id[0], fctr->indep_var[0])
+			    var_get_value_name (fctr->indep_var[0],
+                                                (*fs)->id[0])
 			    );
 
 
@@ -2111,7 +2114,7 @@ show_percentiles (struct variable **depe
 	      if ( fctr->indep_var[1])
 		tab_text (tbl, 2, row,
 			  TAB_LEFT | TAT_TITLE,
-			  value_to_string ((*fs)->id[1], fctr->indep_var[1])
+			  var_get_value_name (fctr->indep_var[1], (*fs)->id[1])
 			  );
 
 
@@ -2213,7 +2216,7 @@ factor_to_string (const struct factor *f
 
   snprintf (buf2, 100, "%s = %s",
 	   var_to_string (fctr->indep_var[0]),
-	   value_to_string (fs->id[0], fctr->indep_var[0]));
+           var_get_value_name (fctr->indep_var[0], fs->id[0]));
 
   strcat (buf1, buf2);
 
@@ -2221,8 +2224,7 @@ factor_to_string (const struct factor *f
     {
       sprintf (buf2, "; %s = %s)",
 	      var_to_string (fctr->indep_var[1]),
-	      value_to_string (fs->id[1],
-			      fctr->indep_var[1]));
+              var_get_value_name (fctr->indep_var[1], fs->id[1]));
       strcat (buf1, buf2);
     }
   else
@@ -2247,11 +2249,12 @@ factor_to_string_concise (const struct f
   char buf2[100];
 
   snprintf (buf, 100, "%s",
-	   value_to_string (fs->id[0], fctr->indep_var[0]));
+            var_get_value_name (fctr->indep_var[0], fs->id[0]));
 
   if ( fctr->indep_var[1] )
     {
-      sprintf (buf2, ",%s)", value_to_string (fs->id[1], fctr->indep_var[1]) );
+      sprintf (buf2, ",%s)", var_get_value_name (fctr->indep_var[1],
+                                                 fs->id[1]) );
       strcat (buf, buf2);
     }
 
Index: src/language/stats/flip.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/flip.c,v
retrieving revision 1.16
diff -u -p -r1.16 flip.c
--- src/language/stats/flip.c	5 Dec 2006 15:10:21 -0000	1.16
+++ src/language/stats/flip.c	10 Dec 2006 03:30:35 -0000
@@ -104,7 +104,7 @@ cmd_flip (struct lexer *lexer, struct da
 
   flip = pool_create_container (struct flip_pgm, pool);
   flip->var = NULL;
-  flip->idx_to_fv = dict_get_compacted_idx_to_fv (dict);
+  flip->idx_to_fv = dict_get_compacted_dict_index_to_case_index (dict);
   pool_register (flip->pool, free, flip->idx_to_fv);
   flip->var_cnt = 0;
   flip->case_cnt = 0;
@@ -327,10 +327,11 @@ flip_sink_write (struct case_sink *sink,
   if (flip->new_names != NULL)
     {
       struct varname *v = pool_alloc (flip->pool, sizeof *v);
+      int fv = flip->idx_to_fv[var_get_dict_index (flip->new_names)];
       v->next = NULL;
       if (var_is_numeric (flip->new_names))
         {
-          double f = case_num (c, flip->idx_to_fv[flip->new_names->index]);
+          double f = case_num_idx (c, fv);
 
           if (f == SYSMIS)
             strcpy (v->name, "VSYSMIS");
@@ -344,8 +345,7 @@ flip_sink_write (struct case_sink *sink,
       else
 	{
 	  int width = MIN (var_get_width (flip->new_names), MAX_SHORT_STRING);
-	  memcpy (v->name, case_str (c, flip->idx_to_fv[flip->new_names->index]),
-                  width);
+	  memcpy (v->name, case_str_idx (c, fv), width);
 	  v->name[width] = 0;
 	}
       
@@ -361,8 +361,11 @@ flip_sink_write (struct case_sink *sink,
     {
       double out;
       
-      if (var_is_numeric (flip->var[i]))
-        out = case_num (c, flip->idx_to_fv[flip->var[i]->index]);
+      if (var_is_numeric (flip->var[i])) 
+        {
+          int fv = flip->idx_to_fv[var_get_dict_index (flip->var[i])];
+          out = case_num_idx (c, fv); 
+        }
       else
         out = SYSMIS;
       flip->output_buf[i].f = out;
@@ -547,7 +550,7 @@ flip_source_read (struct case_source *so
         }
 
       for (j = 0; j < flip->case_cnt; j++)
-        case_data_rw (c, j)->f = input_buf[j].f;
+        case_data_rw_idx (c, j)->f = input_buf[j].f;
       ok = write_case (wc_data);
     }
   free (input_buf);
Index: src/language/stats/frequencies.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/frequencies.q,v
retrieving revision 1.24
diff -u -p -r1.24 frequencies.q
--- src/language/stats/frequencies.q	5 Dec 2006 15:10:21 -0000	1.24
+++ src/language/stats/frequencies.q	10 Dec 2006 03:30:36 -0000
@@ -31,6 +31,7 @@
 
 #include <data/case.h>
 #include <data/dictionary.h>
+#include <data/format.h>
 #include <data/procedure.h>
 #include <data/settings.h>
 #include <data/value-labels.h>
@@ -269,9 +270,7 @@ struct var_freqs
 static inline struct var_freqs *
 get_var_freqs (const struct variable *v)
 {
-  assert (v != NULL);
-  assert (v->aux != NULL);
-  return v->aux;
+  return var_get_aux (v);
 }
 
 static void determine_charts (void);
@@ -516,7 +515,7 @@ calc (const struct ccase *c, void *aux U
   for (i = 0; i < n_variables; i++)
     {
       const struct variable *v = v_variables[i];
-      const union value *val = case_data (c, v->fv);
+      const union value *val = case_data (c, v);
       struct var_freqs *vf = get_var_freqs (v);
       struct freq_tab *ft = &vf->tab;
 
@@ -695,23 +694,22 @@ postcalc (void *aux UNUSED, const struct
    sorting a frequency table by FRQ_SORT using VAR_TYPE
    variables. */
 static hsh_compare_func *
-get_freq_comparator (int frq_sort, int var_type) 
+get_freq_comparator (int frq_sort, enum var_type var_type) 
 {
-  /* Note that q2c generates tags beginning with 1000. */
-  switch (frq_sort | (var_type << 16))
+  bool is_numeric = var_type == VAR_NUMERIC;
+  switch (frq_sort)
     {
-    case FRQ_AVALUE | (NUMERIC << 16):  return compare_value_numeric_a;
-    case FRQ_AVALUE | (ALPHA << 16):    return compare_value_alpha_a;
-    case FRQ_DVALUE | (NUMERIC << 16):  return compare_value_numeric_d;
-    case FRQ_DVALUE | (ALPHA << 16):    return compare_value_alpha_d;
-    case FRQ_AFREQ | (NUMERIC << 16):   return compare_freq_numeric_a;
-    case FRQ_AFREQ | (ALPHA << 16):     return compare_freq_alpha_a;
-    case FRQ_DFREQ | (NUMERIC << 16):   return compare_freq_numeric_d;
-    case FRQ_DFREQ | (ALPHA << 16):     return compare_freq_alpha_d;
-    default: NOT_REACHED ();
+    case FRQ_AVALUE:
+      return is_numeric ? compare_value_numeric_a : compare_value_alpha_a;
+    case FRQ_DVALUE:
+      return is_numeric ? compare_value_numeric_d : compare_value_alpha_d;
+    case FRQ_AFREQ:
+      return is_numeric ? compare_freq_numeric_a : compare_freq_alpha_a;
+    case FRQ_DFREQ:
+      return is_numeric ? compare_freq_numeric_d : compare_freq_alpha_d;
+    default:
+      NOT_REACHED ();
     }
-
-  return 0;
 }
 
 /* Returns true iff the value in struct freq F is non-missing
@@ -840,7 +838,7 @@ frq_custom_variables (struct lexer *lexe
       struct variable *v = v_variables[i];
       struct var_freqs *vf;
 
-      if (v->aux != NULL)
+      if (var_get_aux (v) != NULL)
 	{
 	  msg (SE, _("Variable %s specified multiple times on VARIABLES "
 		     "subcommand."), var_get_name (v));
@@ -933,7 +931,7 @@ frq_custom_grouped (struct lexer *lexer,
           }
 
 	for (i = 0; i < n; i++)
-          if (v[i]->aux == NULL)
+          if (var_get_aux (v[i]) == NULL)
             msg (SE, _("Variables %s specified on GROUPED but not on "
                        "VARIABLES."), var_get_name (v[i]));
           else 
@@ -1217,7 +1215,7 @@ dump_full (struct variable *v)
 
       if (lab)
 	{
-	  const char *label = val_labs_find (v->val_labs, f->v[0]);
+	  const char *label = var_lookup_value_label (v, &f->v[0]);
 	  if (label != NULL)
 	    tab_text (t, 0, r, TAB_LEFT, label);
 	}
@@ -1235,7 +1233,7 @@ dump_full (struct variable *v)
 
       if (lab)
 	{
-	  const char *label = val_labs_find (v->val_labs, f->v[0]);
+	  const char *label = var_lookup_value_label (v, &f->v[0]);
 	  if (label != NULL)
 	    tab_text (t, 0, r, TAB_LEFT, label);
 	}
@@ -1643,7 +1641,7 @@ freq_tab_to_slice_array(const struct fre
     {
       const struct freq *frq = &frq_tab->valid[i];
 
-      slices[i].label = value_to_string(frq->v, var);
+      slices[i].label = var_get_value_name (var, frq->v);
 
       slices[i].magnetude = frq->c;
     }
